// OA99_PLUS_DEMODlg.cpp : implementation file
//

#include "stdafx.h"
#include "D5ScannerS77Demo.h"
#include "D5ScannerS77DemoDlg.h"
#include "D5ScannerS77.h"
#include "D5Global.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

WORD getLum (BYTE *pImage)
{
	int cnt = 0;
	BYTE *p;
	long lLum = 0;
	int i, j;
	for (i = 256 / 8; i < 256 * 7 / 8; i++)
	{
		p = pImage + 192 * i + 192 / 8;
		for (j = 192 / 8; j < 192 * 7 / 8; j++)
		{
			lLum += *p++;
			cnt ++;
		}
	}
	lLum /= cnt;
	lLum = min (lLum, 255);
	return (WORD)lLum;
}

//////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CD5ScannerS77DemoDlg dialog

CD5ScannerS77DemoDlg::CD5ScannerS77DemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CD5ScannerS77DemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CD5ScannerS77DemoDlg)
	m_strFeaPath = _T("");
	m_strMatchResult = _T("");
	m_strMatchTime = _T("");
	m_strMatchNResult = _T("");
	m_strMatchCnt = _T("");
	m_strStatus = _T("");
	m_nLum = 0;
	m_strMark1 = _T("");
	m_strMark2 = _T("");
	m_bContinuous = FALSE;
	m_strFeaLoadPath = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CD5ScannerS77DemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CD5ScannerS77DemoDlg)
	DDX_Control(pDX, IDC_BTN_CHECK_MARK, m_btnCheckMark);
	DDX_Control(pDX, IDC_BTN_SET_MARK, m_btnSetMark);
	DDX_Control(pDX, IDC_BTN_OPEN_DEV, m_btnOpenDev);
	DDX_Control(pDX, IDC_COMBO1, m_comboType);
	DDX_Control(pDX, IDC_BTN_IMAGE, m_btnImage);
	DDX_Text(pDX, IDC_EDIT_FEA_PATH, m_strFeaPath);
	DDX_Text(pDX, IDC_EDIT_MATCH_RESULT, m_strMatchResult);
	DDX_Text(pDX, IDC_EDIT_MATCH_TIME, m_strMatchTime);
	DDX_Text(pDX, IDC_EDIT_MATCHN_RESULT, m_strMatchNResult);
	DDX_Text(pDX, IDC_EDIT_MATCH_CNT, m_strMatchCnt);
	DDX_Text(pDX, IDC_EDIT_STATUS, m_strStatus);
	DDX_Text(pDX, IDC_EDIT_LUM, m_nLum);
	DDX_Text(pDX, IDC_EDIT_MARK1, m_strMark1);
	DDX_Text(pDX, IDC_EDIT_MARK2, m_strMark2);
	DDX_Check(pDX, IDC_CHECK_CONTINUOUS, m_bContinuous);
	DDX_Text(pDX, IDC_EDIT_FEALOAD_PATH, m_strFeaLoadPath);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CD5ScannerS77DemoDlg, CDialog)
	//{{AFX_MSG_MAP(CD5ScannerS77DemoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTN_OPEN_DEV, OnBtnOpenDev)
	ON_WM_TIMER()
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_BTN_BROWSE, OnBtnBrowse)
	ON_BN_CLICKED(IDC_BTN_MATCH, OnBtnMatch)
	ON_BN_CLICKED(IDC_BTN_MATCHN, OnBtnMatchn)
	ON_BN_CLICKED(IDC_BTN_ENUM_DEV, OnBtnEnumDev)
	ON_BN_CLICKED(IDC_BTN_SAVE_IMG, OnBtnSaveImg)
	ON_BN_CLICKED(IDC_BTN_SAVE_FEA, OnBtnSaveFea)
	ON_BN_CLICKED(IDC_BTN_SET_MARK, OnBtnSetMark)
	ON_BN_CLICKED(IDC_BTN_CHECK_MARK, OnBtnCheckMark)
	ON_BN_CLICKED(IDC_BTN_LOAD_FEA, OnBtnLoadFea)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CD5ScannerS77DemoDlg message handlers

BOOL CD5ScannerS77DemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	memset (gpImageCap, 0xFF, 192 * 256);
	m_bContinuous = FALSE;
	UpdateData (false);

	m_btnImage.m_dwWidth  = 192;
	m_btnImage.m_dwHeight = 256;
	m_btnImage.m_pImage = gpImageCap;
	m_btnImage.SetHuePalate();
	m_btnImage.Invalidate ();	

	gbProcessTending = FALSE;

	m_btnSetMark.EnableWindow (FALSE);
	m_btnCheckMark.EnableWindow (FALSE);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CD5ScannerS77DemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CD5ScannerS77DemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CD5ScannerS77DemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CD5ScannerS77DemoDlg::OnBtnOpenDev() 
{
	long  lRet;

	lRet = D5OpenDevice (m_comboType.GetCurSel());

	if (lRet == 0)
	{
		m_strStatus = "Open Device OK";

		m_btnOpenDev.EnableWindow (false);
		m_btnSetMark.EnableWindow (true);
		m_btnCheckMark.EnableWindow (true);
		
		SetTimer (1, 100, NULL);
	}
	else
	{
		m_strStatus = "Open Device Fail";

		m_btnSetMark.EnableWindow (false);
		m_btnCheckMark.EnableWindow (false);
	}	

	UpdateData (false);
}

void CD5ScannerS77DemoDlg::OnTimer(UINT nIDEvent) 
{
	static bool bFingerOn = FALSE;
	static WORD uCircle = 0;
	bool   bFP;

	UpdateData (true);	

	D5GetImage (m_comboType.GetCurSel(), gpImage);

	if (m_bContinuous)
	{
		memcpy (gpImageCap, gpImage, 192 * 256);
	}
	else
	{
		bFP = D5CheckFP (gpImage);
				
		if (bFP)
		{
			if (!bFingerOn)
			{
				uCircle ++;
				if (uCircle >= 2)
				{
					bFingerOn = TRUE;

					D5Beep (m_comboType.GetCurSel(), 40);
					Sleep (100);

					memcpy (gpImageCap, gpImage, 192 * 256);					
					
					gbProcessTending = TRUE;
					OnBtnMatchn ();
				}
			}
		}
		else
		{
			bFingerOn = FALSE;
			uCircle = 0;
		}
	}

	m_nLum = getLum (gpImageCap);
	UpdateData (false);			

	m_btnImage.m_dwWidth  = 192;
	m_btnImage.m_dwHeight = 256;
	m_btnImage.m_pImage = gpImageCap;
	m_btnImage.SetHuePalate();
	m_btnImage.Invalidate ();	
	
	CDialog::OnTimer(nIDEvent);
}

void CD5ScannerS77DemoDlg::OnClose() 
{
	D5CloseDevice (m_comboType.GetCurSel());
	
	CDialog::OnClose();
}

int CD5ScannerS77DemoDlg::LoadFeature(char *strFile, BYTE *pFeature)
{
	CFile f;

	//ֵ
	if (f.Open (strFile, CFile::modeRead) == NULL)
	{
		MessageBox ("File open error!");
		return -1;
	}
	f.Read (pFeature, 256);
	f.Close ();

	return 0;
}

void CD5ScannerS77DemoDlg::OnBtnBrowse() 
{
	CFileDialog fDlg(true, "fea", "",
						OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
						"Feature files (*.fea)|*.fea|");
	short result;
	
	if (fDlg.DoModal() != IDOK)
	{
		return;		
	}

	m_strFeaPath = fDlg.GetPathName();
	UpdateData (FALSE);

	result = LoadFeature (m_strFeaPath.GetBuffer(200), gpFeature2);
	if (result == -1)
	{
		MessageBox ("Invalid Feature File!");
	}	
}


BYTE pFea1[256] =//113 
{
	0x1C, 
	0x13, 0x30, 0x1B, 0x81, 0x1C, 0xA5, 0x5A, 0x41,
	0x1E, 0xB1, 0x05, 0x41, 0x27, 0xAA, 0xC4, 0x21,
	0x3C, 0xAF, 0x04, 0xA1, 0x46, 0x9F, 0x40, 0xE1,
	0x4A, 0x27, 0xC4, 0xA1, 0x58, 0xA4, 0xC4, 0x41,
	0x61, 0x31, 0xC9, 0x61, 0x61, 0x8C, 0x25, 0xE1,
	0x7C, 0x3D, 0x0A, 0x01, 0x86, 0x38, 0xC8, 0xE1,
	0x9A, 0x1E, 0xC9, 0xC1, 0x19, 0x13, 0x95, 0xA2,
	0x27, 0x97, 0x6C, 0xA2, 0x28, 0xBD, 0x86, 0xA2,
	0x42, 0x08, 0xE8, 0xA2, 0x45, 0x9A, 0x2B, 0xA2,
	0x60, 0x9D, 0x6A, 0x82, 0x62, 0x2B, 0x47, 0x02,
	0x66, 0x08, 0x65, 0xE2, 0x67, 0x25, 0xC5, 0x42,
	0x69, 0xA1, 0x01, 0x62, 0x73, 0x90, 0x24, 0x62,
	0x80, 0xB0, 0x1F, 0x02, 0x87, 0x9F, 0xE0, 0x42,
	0x8A, 0x97, 0x1F, 0xE2, 0x8B, 0x26, 0x1E, 0xC2
};

BYTE pFea2[256] =//100
{
	0x19, 
	0x16, 0x2A, 0x95, 0xC1, 0x1C, 0xAA, 0xEB, 0xA1,
	0x24, 0xA8, 0x95, 0x61, 0x39, 0xBA, 0xC3, 0x81,
	0x3C, 0xC0, 0x06, 0x41, 0x49, 0x16, 0xA7, 0x01,
	0x50, 0xA6, 0x28, 0xC1, 0x54, 0xA8, 0x67, 0xE1,
	0x57, 0x12, 0xCF, 0x81, 0x71, 0xAC, 0x23, 0x81,
	0x77, 0x37, 0x1F, 0x01, 0x77, 0xA8, 0x23, 0x21,
	0x7A, 0x2F, 0xA1, 0xC1, 0x90, 0xB1, 0xDE, 0x81,
	0x9A, 0x29, 0xA0, 0xC1, 0x24, 0x16, 0xD1, 0x82,
	0x2D, 0xAE, 0xEC, 0xC2, 0x40, 0x9B, 0x11, 0x22,
	0x44, 0x2D, 0xAA, 0x82, 0x55, 0xA2, 0x10, 0xE2,
	0x5B, 0xB0, 0xAA, 0x22, 0x63, 0x30, 0x26, 0x82,
	0x64, 0xB8, 0xC4, 0x22, 0x87, 0xAB, 0xA2, 0xE2,
	0x9B, 0xA6, 0x23, 0xC2
};

BYTE pFea3[256] =//148
{
	0x25,
	0x0B, 0x22, 0xE6, 0x81, 0x0B, 0x28, 0xD2, 0x41,
	0x0B, 0x37, 0x58, 0x61, 0x0C, 0x3D, 0x42, 0xE1,
	0x14, 0xBA, 0x42, 0x81, 0x19, 0x1B, 0xA5, 0x61,
	0x1F, 0x1D, 0x4F, 0x01, 0x29, 0x31, 0xE8, 0xA1,
	0x39, 0xC0, 0x46, 0xC1, 0x3E, 0x3B, 0xC2, 0x41,
	0x4A, 0xAB, 0xA3, 0xC1, 0x53, 0x2D, 0x8C, 0x81,
	0x56, 0x3D, 0xDD, 0xC1, 0x5F, 0x18, 0x4E, 0x21,
	0x60, 0x32, 0xA1, 0xC1, 0x61, 0xBF, 0x5E, 0x81,
	0x77, 0xAE, 0x21, 0x21, 0x77, 0xBA, 0x9E, 0x81,
	0x86, 0x29, 0x61, 0xE1, 0x9A, 0x37, 0x87, 0xA1,
	0x9B, 0x2E, 0xC7, 0x41, 0x13, 0xBD, 0x1B, 0x82,
	0x16, 0x1D, 0xCF, 0x42, 0x1B, 0xAA, 0x91, 0xE2,
	0x1C, 0x35, 0xEC, 0xA2, 0x2E, 0x3A, 0x02, 0x42,
	0x35, 0x32, 0xA7, 0x02, 0x3C, 0x9D, 0x8E, 0xA2,
	0x3E, 0x3F, 0x45, 0x62, 0x4C, 0x38, 0x92, 0x02,
	0x53, 0xBB, 0xE1, 0x62, 0x56, 0xB6, 0xA2, 0xA2,
	0x5A, 0x2C, 0xA3, 0xC2, 0x60, 0x9C, 0xCE, 0x82,
	0x66, 0x28, 0x64, 0x22, 0x6A, 0xAD, 0x63, 0x82,
	0x99, 0x2A, 0x45, 0x62,
};

BYTE pFea5[256] = 
{
	0x2A,
	0x14, 0xA7, 0xD5, 0xC1, 0x1C, 0x25, 0x16, 0x01,
	0x23, 0x9F, 0x92, 0xA1, 0x23, 0xA8, 0x56, 0xC1,
	0x27, 0x16, 0x4F, 0x61, 0x27, 0x22, 0xE8, 0xE1,
	0x2A, 0x1A, 0xCF, 0xA1, 0x2E, 0x19, 0x0D, 0x41,
	0x31, 0x9C, 0x90, 0xA1, 0x44, 0xB1, 0x84, 0x41,
	0x4D, 0xAF, 0xC2, 0x81, 0x4F, 0xAA, 0xA5, 0xC1,
	0x6D, 0x1C, 0x23, 0x21, 0x70, 0x94, 0xE0, 0xC1,
	0x77, 0x1C, 0x63, 0x21, 0x7F, 0x1F, 0x62, 0xE1,
	0x80, 0xAC, 0x9F, 0x81, 0x8B, 0xAA, 0xDF, 0x41,
	0x0F, 0xA9, 0xEB, 0xA2, 0x1F, 0xA5, 0xEB, 0x02,
	0x21, 0x9D, 0x26, 0x02, 0x22, 0x94, 0xCE, 0xE2,
	0x36, 0x30, 0x83, 0x82, 0x3A, 0x92, 0x20, 0x82,
	0x3E, 0x9D, 0x8E, 0xA2, 0x42, 0x9A, 0x8B, 0x22,
	0x46, 0xAF, 0x81, 0xC2, 0x4A, 0x13, 0x89, 0xC2,
	0x4B, 0xA1, 0x4D, 0x42, 0x4E, 0xB4, 0x8B, 0x82,
	0x4E, 0xB8, 0x62, 0x02, 0x50, 0x25, 0x4E, 0x22,
	0x52, 0xAE, 0x21, 0xC2, 0x58, 0x94, 0xCA, 0xE2,
	0x5A, 0x25, 0x8C, 0x22, 0x5C, 0xB1, 0xA2, 0xA2,
	0x6D, 0x29, 0xA1, 0x82, 0x71, 0x9E, 0x8B, 0x42,
	0x73, 0xB6, 0x5D, 0xA2, 0x81, 0x22, 0xE0, 0xE2,
	0x91, 0x1A, 0xA2, 0xE2, 0x92, 0x30, 0x88, 0x82	
};

BYTE pFea6[256] = 
{
	0x20,
	0x24, 0x23, 0x2C, 0xA1, 0x40, 0xC0, 0x4A, 0x01,
	0x4E, 0x94, 0x26, 0x81, 0x51, 0x39, 0xE0, 0x01,
	0x60, 0x40, 0x48, 0xC1, 0x69, 0xB5, 0xA0, 0x41,
	0x82, 0xAB, 0x4D, 0x81, 0x8D, 0xA5, 0x0D, 0xC1,
	0x11, 0xA2, 0x97, 0x62, 0x13, 0x27, 0x01, 0x22,
	0x19, 0x2A, 0x1B, 0x42, 0x21, 0x16, 0x12, 0x02,
	0x2E, 0x2F, 0x86, 0x82, 0x30, 0xBE, 0xC8, 0x02,
	0x40, 0x9D, 0x53, 0xA2, 0x47, 0xBC, 0x08, 0x82,
	0x4D, 0x16, 0xD0, 0xC2, 0x56, 0xA5, 0xE1, 0x62,
	0x58, 0x32, 0x49, 0xC2, 0x5B, 0x28, 0xC9, 0xC2,
	0x5B, 0x35, 0x61, 0x62, 0x5E, 0x23, 0xE3, 0x22,
	0x63, 0xAB, 0x21, 0xC2, 0x77, 0x2F, 0x62, 0xC2,
	0x77, 0x93, 0x8D, 0x02, 0x7C, 0x96, 0xCE, 0x42,
	0x81, 0x33, 0x61, 0xE2, 0x86, 0x17, 0x0D, 0x82,
	0x87, 0x29, 0x64, 0xA2, 0x88, 0x1C, 0xE2, 0x02,
	0x8A, 0x20, 0x4D, 0xE2, 0x8D, 0x34, 0xA1, 0xC2
};

BYTE pFea1_T50[256] =
{
	0x28, 
	0x08, 0xAD, 0xD9, 0x21, 0x16, 0x98, 0x13, 0x21,
	0x1D, 0x28, 0x59, 0x61, 0x22, 0xA3, 0xD8, 0x01,
	0x29, 0x16, 0x52, 0x41, 0x41, 0x1E, 0xA2, 0xE1,
	0x45, 0x8B, 0x90, 0x41, 0x4F, 0x0B, 0x93, 0x01,
	0x54, 0x0F, 0x14, 0xA1, 0x5A, 0x08, 0x94, 0xC1,
	0x5A, 0x3E, 0x20, 0x41, 0x5F, 0x22, 0x68, 0x01,
	0x6E, 0x21, 0xE8, 0x81, 0x76, 0x08, 0x98, 0x01,
	0x79, 0x38, 0x50, 0x41, 0x80, 0x0E, 0xC0, 0x61, 
	0x80, 0x21, 0x51, 0xC1, 0x81, 0x2E, 0x51, 0xC1, 
	0x85, 0x11, 0x97, 0x01, 0x8B, 0x29, 0x92, 0x41, 
	0x8C, 0x2E, 0x53, 0x21, 0x98, 0xAB, 0x95, 0x01, 
	0x11, 0x90, 0xD1, 0x82, 0x27, 0x1D, 0xD5, 0xE2, 
	0x30, 0x98, 0xD3, 0xC2, 0x31, 0xB1, 0xDE, 0x42, 
	0x34, 0x3B, 0x5F, 0x22, 0x35, 0x9D, 0x17, 0x82, 
	0x43, 0x8F, 0xD1, 0xA2, 0x45, 0x2D, 0xE0, 0xE2, 
	0x4E, 0x9C, 0x27, 0xE2, 0x56, 0xB7, 0x23, 0x42, 
	0x57, 0x1C, 0x67, 0xC2, 0x5A, 0x3B, 0x22, 0x62, 
	0x67, 0x3B, 0xA2, 0xA2, 0x6C, 0x3E, 0x20, 0x22, 
	0x7C, 0x8F, 0x95, 0x42, 0x81, 0x16, 0x13, 0xC2, 
	0x8F, 0x9D, 0x94, 0xA2, 0x95, 0x8E, 0xD7, 0xA2 
};

BYTE pByteTmp[256] =
{
	0x20, 
	0x12, 0x98, 0xD2, 0x21, 0x22, 0x9F, 0x13, 0x81,
	0x27, 0x2E, 0x5C, 0xC1, 0x2F, 0x22, 0x55, 0xE1,
	0x35, 0xA8, 0xDC, 0xE1, 0x36, 0x36, 0x9F, 0xC1,
	0x48, 0xA2, 0xA0, 0xA1, 0x4D, 0x38, 0x60, 0x81,
	0x54, 0x96, 0xA3, 0xC1, 0x55, 0x24, 0x23, 0x61,
	0x5F, 0xA7, 0xCD, 0x41, 0x60, 0xA2, 0x4D, 0x61,
	0x65, 0x35, 0xE2, 0xE1, 0x69, 0x12, 0x4E, 0xA1,
	0x72, 0x2C, 0x0F, 0xA1, 0x79, 0xAF, 0x91, 0x61,
	0x7D, 0x17, 0x11, 0xE1, 0x87, 0x2E, 0x53, 0x21,
	0x8A, 0x29, 0x92, 0x41, 0x23, 0xB6, 0x1D, 0x02,
	0x30, 0x31, 0x86, 0x82, 0x32, 0xB7, 0x87, 0x22,
	0x38, 0x1A, 0x0F, 0xA2, 0x58, 0x98, 0x4D, 0xE2,
	0x5A, 0x3B, 0x60, 0x82, 0x67, 0x17, 0xCF, 0xA2,
	0x7D, 0x34, 0x52, 0xA2, 0x81, 0x3B, 0xAC, 0x62,
	0x83, 0x22, 0x91, 0xA2, 0x90, 0xB3, 0xD4, 0x42,
	0x96, 0x19, 0x14, 0x02, 0x96, 0x22, 0x93, 0xA2,
};

BYTE pFeaTmp2[256] =
{
	0x13,
	0x0F, 0x32, 0xAA, 0x01, 0x16, 0xAF, 0x92, 0xE1,
	0x18, 0xA3, 0x12, 0xE1, 0x29, 0xBA, 0x15, 0x01,
	0x2D, 0x11, 0x12, 0x81, 0x2D, 0x98, 0x53, 0x41,
	0x34, 0x8B, 0xA8, 0xA1, 0x3D, 0xBE, 0x56, 0x81,
	0x44, 0xBD, 0x80, 0x01, 0x49, 0x0D, 0x29, 0xC1,
	0x5B, 0xA4, 0x14, 0x41, 0x71, 0xBA, 0x01, 0x01,
	0x72, 0x22, 0xD4, 0x21, 0x74, 0x9B, 0xA8, 0xE1,
	0x7B, 0x2E, 0x56, 0x61, 0x9C, 0x2A, 0xD5, 0x61,
	0x48, 0x1C, 0xD2, 0xE2, 0x5A, 0x1C, 0x52, 0x62,
	0x5E, 0x92, 0xA8, 0xC2, 0x11, 0x89, 0x12, 0x10,
	0x12, 0x99, 0x13, 0x24, 0x13, 0xB1, 0x14, 0x40,
	0x14, 0xD1, 0x15, 0x64, 0x15, 0xF9, 0x16, 0x90,
};

BYTE pFeaTmp3[256] =
{
	0x29, 
	0x10, 0xA8, 0xEA, 0xA1, 0x16, 0x29, 0x95, 0xE1,
	0x17, 0x2F, 0xC1, 0xA1, 0x17, 0xA3, 0x54, 0x21,
	0x1E, 0x9A, 0x68, 0xC1, 0x22, 0x15, 0xA7, 0x61,
	0x25, 0x9A, 0x67, 0xE1, 0x26, 0xA2, 0x29, 0xA1,
	0x27, 0x33, 0xC3, 0x41, 0x28, 0x2B, 0x99, 0xA1,
	0x3A, 0x38, 0x07, 0x01, 0x40, 0xB6, 0x9E, 0x41,
	0x4B, 0x23, 0x24, 0xA1, 0x4D, 0xA8, 0x60, 0x41,
	0x4E, 0x32, 0x1F, 0xA1, 0x54, 0x8E, 0xE5, 0x01,
	0x55, 0x17, 0xCE, 0x61, 0x56, 0x25, 0xE2, 0x41,
	0x6E, 0xB5, 0xDF, 0x21, 0x74, 0x0E, 0x11, 0x01,
	0x75, 0x2A, 0xA3, 0x21, 0x77, 0x11, 0x90, 0xC1,
	0x7F, 0x1D, 0x51, 0x21, 0x80, 0x32, 0x99, 0x81,
	0x91, 0xB4, 0x40, 0x61, 0x22, 0x28, 0x57, 0x22,
	0x29, 0x27, 0xAC, 0xA2, 0x2A, 0x32, 0x5B, 0x82,
	0x30, 0x92, 0x0F, 0x82, 0x33, 0x9E, 0x92, 0x02,
	0x3D, 0x24, 0xD6, 0xE2, 0x4C, 0x25, 0x23, 0xC2,
	0x4F, 0x8C, 0x4E, 0x82, 0x59, 0x2E, 0x20, 0x62,
	0x59, 0xA9, 0xCB, 0x82, 0x5E, 0x0C, 0xCF, 0x02,
	0x66, 0xA9, 0xA3, 0x22, 0x69, 0xAE, 0xE2, 0x02,
	0x74, 0x2C, 0xCC, 0x42, 0x7E, 0xA9, 0xE5, 0x82,
	0x83, 0x11, 0x93, 0x22, 0x30, 0x21, 0x31, 0x00,
	0x1A, 0x03, 0x9C, 0xD2, 0x01, 0x08, 0x25, 0x93,
	0x21, 0x1C, 0xAB, 0xAA, 0x01, 0x21, 0x14, 0x10
};

void CD5ScannerS77DemoDlg::OnBtnMatch() 
{
	long result;
	int i;

	if (gbProcessTending) D5Process (gpImageCap, gpFeature);

	result = D5Match (gpFeature, gpFeature2, 180, 5);
	if (result == 0)
	{
		m_strMatchResult = "OK";

		D5CloseLED (m_comboType.GetCurSel(), LED_B);		
		D5OpenLED (m_comboType.GetCurSel(), LED_G);
		for (i = 0; i < 3; i++)
		{
			D5Beep (m_comboType.GetCurSel(), 40);
			Sleep (40);
		}
		D5CloseLED (m_comboType.GetCurSel(), LED_G);
		D5OpenLED (m_comboType.GetCurSel(), LED_B);		
	}
	else
	{
		m_strMatchResult = "FAIL";

		D5CloseLED (m_comboType.GetCurSel(), LED_B);		
		D5OpenLED (m_comboType.GetCurSel(), LED_R);
		D5Beep (m_comboType.GetCurSel(), 160);
		D5CloseLED (m_comboType.GetCurSel(), LED_R);
		D5OpenLED (m_comboType.GetCurSel(), LED_B);		
	}
	UpdateData (false);	
}

char gpFileName[1000][256];
BYTE gpFeaBuf[1000][256];

void CD5ScannerS77DemoDlg::OnBtnMatchn() 
{
	char pDirName[200];
	char pPathName[200];
	HANDLE hSearch;
	bool bSearch;
	long result;
	WIN32_FIND_DATA fd;
	DWORD tMatch;
	int  uFeaCnt;
	int  i;

	if (gbProcessTending) D5Process (gpImageCap, gpFeature);

	GetModuleFileName (NULL, pDirName, 200);
	for (i = strlen (pDirName) - 1; i >= 0; i --)
	{
		if (pDirName[i] == '\\') break;
	}
	pDirName[i + 1] = 0;

	strcpy (pPathName, pDirName);
	strcat (pPathName, "*.fea");
	
	uFeaCnt = 0;
	hSearch = FindFirstFile (pPathName, &fd);
	if ((DWORD)hSearch != 0xFFFFFFFF)
	{
		while (1)
		{
			if (uFeaCnt <= 1000)
			{
				strcpy (pPathName, pDirName);
				strcat (pPathName, fd.cFileName);
				strcpy (gpFileName[uFeaCnt], fd.cFileName);
				result = LoadFeature (pPathName, gpFeaBuf[uFeaCnt]);		
				if (result == -1)
				{
					MessageBox ("Invalid Feature File!");
					return;
				}
				uFeaCnt ++;
			}
			bSearch = FindNextFile (hSearch, &fd);
			if (!bSearch) break;
		}
	}

	tMatch = GetTickCount ();
	result = D5MatchN (gpFeature, gpFeaBuf, uFeaCnt, 180, 5);
	tMatch = GetTickCount () - tMatch;

	if (result >= 0) 
	{
		strcpy (m_strMatchNResult.GetBuffer(100), gpFileName[result]);
		strcat (m_strMatchNResult.GetBuffer(100), " OK");

		D5CloseLED (m_comboType.GetCurSel(), LED_B);
		D5OpenLED (m_comboType.GetCurSel(), LED_G);
		for (i = 0; i < 3; i++)
		{
			D5Beep (m_comboType.GetCurSel(), 40);
			Sleep (40);
		}
		D5CloseLED (m_comboType.GetCurSel(), LED_G);
		D5OpenLED (m_comboType.GetCurSel(), LED_B);
		
	}
	else 
	{
		strcpy (m_strMatchNResult.GetBuffer(100), "All FAIL");

		D5CloseLED (m_comboType.GetCurSel(), LED_B);		
		D5OpenLED (m_comboType.GetCurSel(), LED_R);
		D5Beep (m_comboType.GetCurSel(), 160);
		D5CloseLED (m_comboType.GetCurSel(), LED_R);
		D5OpenLED (m_comboType.GetCurSel(), LED_B);		
	}
	itoa (uFeaCnt, m_strMatchCnt.GetBuffer(100), 10);
	itoa (tMatch, m_strMatchTime.GetBuffer(100), 10);
	UpdateData (false);	
}

void CD5ScannerS77DemoDlg::OnBtnEnumDev() 
{
	char pName[8][128];
	short iNum;
	int  i;

	m_comboType.ResetContent();
	
	iNum = D5EnumDevice (pName);

	for (i = 0; i < iNum; i++)
	{
		m_comboType.AddString (pName[i]);
	}
	m_comboType.SetCurSel (0);

	m_strStatus = "";
	UpdateData (false);

	if (iNum >= 1) m_btnOpenDev.EnableWindow (true);
}

void CD5ScannerS77DemoDlg::OnBtnSaveImg() 
{
	CFileDialog fDlg(false, "bmp", "",
					OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
					"Bmp files (*.bmp)|*.bmp|");

	if (fDlg.DoModal () != IDOK) return;

	D5SaveBMPFile (fDlg.GetPathName().GetBuffer (200), gpImageCap);
}

void CD5ScannerS77DemoDlg::OnBtnSaveFea() 
{
	CFileDialog fDlg(false, "fea","",
						OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
						"template files (*.fea)|*.fea|");
	unsigned char pBuffer[500];
	CFile f;
	WORD uLen;	
	
	if (fDlg.DoModal () != IDOK) return;
	if (f.Open (fDlg.GetPathName(), CFile::modeCreate | CFile::modeWrite) == NULL)
	{
		MessageBox ("File open error!");
		return;
	}

	f.Write (gpFeature, 256);
	f.Close ();	
}

void CD5ScannerS77DemoDlg::OnBtnSetMark() 
{
	BYTE  pMark[8];
	BYTE  uByte;
	long  lRet;
	int   i;

	UpdateData (true);

	if (m_strMark1.GetLength() != 16) 
	{
		MessageBox ("8 Bytes Required");
		return;
	}

	for (i = 0; i < 8; i++)
	{
		uByte = m_strMark1.GetAt (2 * i);
		pMark[i] = uByte >= 'A'? uByte - 'A' + 10: uByte - '0'; 
		pMark[i] <<= 4;
		uByte = m_strMark1.GetAt (2 * i + 1);
		pMark[i] += uByte >= 'A'? uByte - 'A' + 10: uByte - '0'; 
	}

	lRet = D5SetMark (m_comboType.GetCurSel(), pMark);

	if (lRet == 0)
	{
		MessageBox ("Set Mark OK");
	}
	else
	{
		MessageBox ("Set Mark Fail");
	}	
}

void CD5ScannerS77DemoDlg::OnBtnCheckMark() 
{
	BYTE  pMark[8];
	BYTE  uByte;
	long  lRet;
	int   i;

	UpdateData (true);

	if (m_strMark2.GetLength() != 16) 
	{
		MessageBox ("8 Bytes Required");
		return;
	}

	for (i = 0; i < 8; i++)
	{
		uByte = m_strMark2.GetAt (2 * i);
		pMark[i] = uByte >= 'A'? uByte - 'A' + 10: uByte - '0'; 
		pMark[i] <<= 4;
		uByte = m_strMark2.GetAt (2 * i + 1);
		pMark[i] += uByte >= 'A'? uByte - 'A' + 10: uByte - '0'; 
	}

	lRet = D5CheckMark (m_comboType.GetCurSel(), pMark);

	if (lRet == 0)
	{
		MessageBox ("Check Mark OK");
	}
	else
	{
		MessageBox ("Check Mark Fail");
	}
}

void CD5ScannerS77DemoDlg::OnBtnLoadFea() 
{
	CFileDialog fDlg(true, "fea", "",
						OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
						"Feature files (*.fea)|*.fea|");
	short result;
	
	if (fDlg.DoModal() != IDOK)
	{
		return;		
	}

	m_strFeaLoadPath = fDlg.GetPathName();
	UpdateData (FALSE);

	result = LoadFeature (m_strFeaLoadPath.GetBuffer(200), gpFeature);
	if (result == -1)
	{
		MessageBox ("Invalid Feature File!");
	}
	
	gbProcessTending = FALSE;
}
